"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDefaultModel = createDefaultModel;
exports.model = model;
exports.normalize = void 0;
exports.outcome = outcome;
exports.validate = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _debug = _interopRequireDefault(require("debug"));

var _feedback = require("@pie-lib/pie-toolbox/feedback");

var _defaults = _interopRequireDefault(require("./defaults"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var log = (0, _debug["default"])('@pie-element:extended-text-entry:controller');

function createDefaultModel() {
  return _createDefaultModel.apply(this, arguments);
}

function _createDefaultModel() {
  _createDefaultModel = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var model,
        _args = arguments;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            model = _args.length > 0 && _args[0] !== undefined ? _args[0] : {};
            log('[createDefaultModel]', model);
            return _context.abrupt("return", _objectSpread(_objectSpread({}, _defaults["default"]), model));

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _createDefaultModel.apply(this, arguments);
}

var normalize = function normalize(question) {
  return _objectSpread(_objectSpread({}, _defaults["default"]), question);
};

exports.normalize = normalize;

function model(_x, _x2, _x3) {
  return _model.apply(this, arguments);
}

function _model() {
  _model = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(question, session, env) {
    var normalizedQuestion, fb, teacherInstructions, equationEditor, annotatorMode;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            log('[question]', question);
            normalizedQuestion = normalize(question);
            fb = env.mode === 'evaluate' && normalizedQuestion.feedbackEnabled ? (0, _feedback.getFeedback)(normalizedQuestion.feedback, 'Your answer has been submitted') : Promise.resolve(undefined);
            teacherInstructions = null;

            if (env.role === 'instructor' && (env.mode === 'view' || env.mode === 'evaluate')) {
              teacherInstructions = normalizedQuestion.teacherInstructionsEnabled ? normalizedQuestion.teacherInstructions : null;
            } else {
              teacherInstructions = null;
            }

            equationEditor = normalizedQuestion.equationEditor || 'miscellaneous';
            _context2.t0 = normalizedQuestion.equationEditor;
            _context2.next = _context2.t0 === 'Grade 1 - 2' ? 9 : _context2.t0 === 'Grade 3 - 5' ? 11 : _context2.t0 === 'Grade 6 - 7' ? 13 : _context2.t0 === 'Grade 8 - HS' ? 15 : 17;
            break;

          case 9:
            equationEditor = 1;
            return _context2.abrupt("break", 18);

          case 11:
            equationEditor = 3;
            return _context2.abrupt("break", 18);

          case 13:
            equationEditor = 6;
            return _context2.abrupt("break", 18);

          case 15:
            equationEditor = 8;
            return _context2.abrupt("break", 18);

          case 17:
            return _context2.abrupt("break", 18);

          case 18:
            annotatorMode = normalizedQuestion.annotationsEnabled && (env.role === 'instructor' || env.mode === 'evaluate');
            return _context2.abrupt("return", fb.then(function (feedback) {
              return {
                prompt: normalizedQuestion.promptEnabled ? normalizedQuestion.prompt : null,
                dimensions: normalizedQuestion.dimensions,
                customKeys: normalizedQuestion.customKeys || [],
                id: normalizedQuestion.id,
                disabled: env.mode !== 'gather',
                feedback: feedback,
                teacherInstructions: teacherInstructions,
                language: normalizedQuestion.language,
                mathInput: normalizedQuestion.mathInput,
                spanishInput: normalizedQuestion.spanishInput,
                specialInput: normalizedQuestion.specialInput,
                equationEditor: equationEditor,
                spellCheckEnabled: !normalizedQuestion.playerSpellCheckDisabled,
                playersToolbarPosition: normalizedQuestion.playersToolbarPosition || 'bottom',
                annotatorMode: annotatorMode,
                disabledAnnotator: normalizedQuestion.annotationsEnabled ? env.role !== 'instructor' : true,
                predefinedAnnotations: normalizedQuestion.annotationsEnabled ? normalizedQuestion.predefinedAnnotations : [],
                extraCSSRules: normalizedQuestion.extraCSSRules
              };
            }));

          case 20:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _model.apply(this, arguments);
}

function
  /*question, session, env*/
outcome() {
  return _outcome.apply(this, arguments);
} // remove all html tags


function _outcome() {
  _outcome = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", {
              score: 0,
              completed: 'n/a',
              note: 'Requires manual scoring'
            });

          case 1:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _outcome.apply(this, arguments);
}

var getInnerText = function getInnerText(html) {
  return (html || '').replaceAll(/<[^>]*>/g, '');
}; // remove all html tags except img, iframe and source tag for audio


var getContent = function getContent(html) {
  return (html || '').replace(/(<(?!img|iframe|source)([^>]+)>)/gi, '');
};

var validate = function validate() {
  var model = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var errors = {};
  ['teacherInstructions', 'prompt'].forEach(function (field) {
    var _config$field;

    if ((_config$field = config[field]) !== null && _config$field !== void 0 && _config$field.required && !getContent(model[field])) {
      errors[field] = 'This field is required.';
    }
  });
  return errors;
};

exports.validate = validate;
//# sourceMappingURL=index.js.map