"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _core = require("@material-ui/core");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles = function styles(theme) {
  return {
    mainWrapper: {
      width: '300px',
      overflow: 'hidden',
      borderRadius: '4px',
      backgroundColor: theme.palette.common.white,
      border: "2px solid ".concat(theme.palette.grey[100])
    },
    annotationsWrapper: {
      display: 'flex',
      flexWrap: 'wrap'
    },
    controlsWrapper: {
      display: 'flex',
      flexWrap: 'wrap',
      borderTop: "2px solid ".concat(theme.palette.grey[100])
    },
    button: {
      width: '22%',
      textAlign: 'center',
      padding: '4px',
      cursor: 'pointer',
      borderBottom: "1px solid ".concat(theme.palette.grey[100]),
      '&:not(:nth-child(4n))': {
        borderRight: "1px solid ".concat(theme.palette.grey[100])
      },
      '&:nth-child(4n)': {
        flexGrow: 1
      },
      '&:hover': {
        backgroundColor: theme.palette.grey[100]
      }
    },
    positive: {
      backgroundColor: 'rgb(153, 255, 153) !important',
      '&:hover': {
        filter: 'brightness(85%)'
      }
    },
    negative: {
      backgroundColor: 'rgb(255, 204, 238) !important',
      '&:hover': {
        filter: 'brightness(85%)'
      }
    },
    holder: {
      display: 'flex',
      flexWrap: 'wrap',
      borderTop: "2px solid ".concat(theme.palette.grey[100])
    },
    arrow: {
      overflowX: 'unset',
      overflowY: 'unset',
      marginTop: '-16px',
      '&::after': {
        position: 'absolute',
        left: 'calc(50% - 7px)',
        // bottom: 0,
        border: 'solid transparent',
        content: '""',
        height: 0,
        width: 0,
        pointerEvents: 'none',
        borderWidth: '7px',
        borderTopColor: 'black'
      }
    }
  };
};

var AnnotationMenu = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(AnnotationMenu, _React$Component);

  var _super = _createSuper(AnnotationMenu);

  function AnnotationMenu() {
    (0, _classCallCheck2["default"])(this, AnnotationMenu);
    return _super.apply(this, arguments);
  }

  (0, _createClass2["default"])(AnnotationMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          anchorEl = _this$props.anchorEl,
          annotations = _this$props.annotations,
          classes = _this$props.classes,
          isNewAnnotation = _this$props.isNewAnnotation,
          onAnnotate = _this$props.onAnnotate,
          onClose = _this$props.onClose,
          onEdit = _this$props.onEdit,
          onDelete = _this$props.onDelete,
          onWrite = _this$props.onWrite,
          open = _this$props.open;
      return /*#__PURE__*/_react["default"].createElement(_core.Popover, {
        anchorEl: anchorEl,
        open: open,
        onClose: onClose,
        classes: {
          paper: classes.arrow
        },
        elevation: 5,
        anchorOrigin: {
          vertical: 'top',
          horizontal: 'center'
        },
        transformOrigin: {
          vertical: 'bottom',
          horizontal: 'center'
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.mainWrapper
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.annotationsWrapper
      }, annotations.map(function (annotation, index) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          key: "annotation-".concat(index),
          className: (0, _classnames["default"])(classes.button, annotation.type === 'positive' ? classes.positive : classes.negative),
          onClick: function onClick() {
            return onAnnotate(annotation);
          }
        }, annotation.label);
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.controlsWrapper
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.button,
        onClick: onClose
      }, "Cancel"), /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          pointerEvents: 'none'
        },
        className: classes.button
      }), isNewAnnotation ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.button, classes.positive),
        onClick: function onClick() {
          return onWrite('positive');
        }
      }, "Write"), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.button, classes.negative),
        onClick: function onClick() {
          return onWrite('negative');
        }
      }, "Write")) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.button,
        onClick: onDelete
      }, "Delete"), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.button,
        onClick: onEdit
      }, "Edit")))));
    }
  }]);
  return AnnotationMenu;
}(_react["default"].Component);

(0, _defineProperty2["default"])(AnnotationMenu, "propTypes", {
  anchorEl: _propTypes["default"].object,
  open: _propTypes["default"].bool,
  annotations: _propTypes["default"].array,
  isNewAnnotation: _propTypes["default"].bool,
  onClose: _propTypes["default"].func,
  onDelete: _propTypes["default"].func,
  onEdit: _propTypes["default"].func,
  onWrite: _propTypes["default"].func,
  onAnnotate: _propTypes["default"].func
});

var _default = (0, _styles.withStyles)(styles)(AnnotationMenu);

exports["default"] = _default;
//# sourceMappingURL=annotation-menu.js.map