"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _styles = require("@material-ui/core/styles");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var styles = function styles(theme) {
  return {
    wrapper: {
      width: '200px',
      overflow: 'hidden',
      borderRadius: '4px',
      backgroundColor: '#ffffff',
      border: "4px solid ".concat(theme.palette.grey[100]),
      '&.negative': {
        borderColor: 'rgb(255, 204, 238) !important'
      },
      '&.positive': {
        borderColor: 'rgb(153, 255, 153) !important'
      }
    },
    holder: {
      display: 'flex',
      flexWrap: 'wrap',
      borderTop: "2px solid ".concat(theme.palette.grey[100])
    },
    positive: {
      backgroundColor: 'rgb(153, 255, 153) !important',
      '&:hover': {
        filter: 'brightness(85%)'
      }
    },
    negative: {
      backgroundColor: 'rgb(255, 204, 238) !important',
      '&:hover': {
        filter: 'brightness(85%)'
      }
    },
    button: {
      flexGrow: 1,
      width: '28%',
      textAlign: 'center',
      padding: '4px',
      cursor: 'pointer',
      '&:not(:nth-child(3n))': {
        borderRight: "1px solid ".concat(theme.palette.grey[100])
      },
      '&:hover': {
        backgroundColor: theme.palette.grey[100]
      },
      '&.negative:hover': {
        backgroundColor: 'rgb(153, 255, 153) !important'
      },
      '&.positive:hover': {
        backgroundColor: 'rgb(255, 204, 238) !important'
      }
    },
    arrow: {
      overflowX: 'unset',
      overflowY: 'unset',
      marginLeft: '16px',
      '&::before': {
        position: 'absolute',
        right: '100%',
        top: '13px',
        border: 'solid transparent',
        content: '""',
        height: 0,
        width: 0,
        pointerEvents: 'none',
        borderWidth: '7px',
        borderRightColor: theme.palette.grey[100]
      },
      '&.negative::before': {
        borderRightColor: 'rgb(255, 204, 238) !important'
      },
      '&.positive::before': {
        borderRightColor: 'rgb(153, 255, 153) !important'
      }
    }
  };
};

var FreeformEditor = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(FreeformEditor, _React$Component);

  var _super = _createSuper(FreeformEditor);

  function FreeformEditor(props) {
    var _this;

    (0, _classCallCheck2["default"])(this, FreeformEditor);
    _this = _super.call(this, props);
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onValueChange", function (event) {
      return _this.setState({
        value: event.target.value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSave", function () {
      var _this$props = _this.props,
          oldValue = _this$props.value,
          onSave = _this$props.onSave,
          onClose = _this$props.onClose,
          onDelete = _this$props.onDelete;
      var value = _this.state.value;

      if (value === '') {
        onDelete();
      }

      if (oldValue !== value) {
        onSave(oldValue, value);
      }

      _this.setState({
        value: ''
      });

      onClose();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleTypeChange", function () {
      var _this$props2 = _this.props,
          onTypeChange = _this$props2.onTypeChange,
          onDelete = _this$props2.onDelete;
      var value = _this.state.value;

      if (value === '') {
        onDelete();
      } else {
        onTypeChange(value);
      }

      _this.setState({
        value: ''
      });
    });
    _this.state = {
      value: props.value
    };
    return _this;
  }

  (0, _createClass2["default"])(FreeformEditor, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var value = nextProps.value;
      var propsValue = this.props.value;

      if (value !== propsValue) {
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          anchorEl = _this$props3.anchorEl,
          classes = _this$props3.classes,
          offset = _this$props3.offset,
          onDelete = _this$props3.onDelete,
          open = _this$props3.open,
          type = _this$props3.type;
      var value = this.state.value;
      return /*#__PURE__*/_react["default"].createElement(_core.Popover, {
        anchorEl: anchorEl,
        elevation: 2,
        open: open,
        onClose: this.handleSave,
        classes: {
          paper: (0, _classnames["default"])(classes.arrow, type)
        },
        style: {
          marginTop: "".concat(offset, "px"),
          transition: 'margin-top 2s ease-out'
        },
        anchorOrigin: {
          vertical: 'top',
          horizontal: 'right'
        },
        transformOrigin: {
          vertical: 'top',
          horizontal: 'left'
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.wrapper, type)
      }, /*#__PURE__*/_react["default"].createElement(_core.TextField, {
        id: "annotation-editor",
        style: {
          padding: '2px 5px',
          width: '95%'
        },
        autoFocus: true,
        multiline: true,
        rows: 1,
        rowsMax: 4,
        value: value,
        onChange: this.onValueChange,
        InputProps: {
          disableUnderline: true
        }
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.holder
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.button,
        onClick: onDelete
      }, "Delete"), /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(classes.button, type),
        onClick: this.handleTypeChange
      }, type === 'negative' ? 'Green' : 'Pink'), /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.button,
        onClick: this.handleSave
      }, "Save"))));
    }
  }]);
  return FreeformEditor;
}(_react["default"].Component);

(0, _defineProperty2["default"])(FreeformEditor, "propTypes", {
  anchorEl: _propTypes["default"].object,
  open: _propTypes["default"].bool,
  offset: _propTypes["default"].number,
  value: _propTypes["default"].string,
  type: _propTypes["default"].string,
  onClose: _propTypes["default"].func,
  onDelete: _propTypes["default"].func,
  onSave: _propTypes["default"].func,
  onTypeChange: _propTypes["default"].func
});

var _default = (0, _styles.withStyles)(styles)(FreeformEditor);

exports["default"] = _default;
//# sourceMappingURL=freeform-editor.js.map