"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.isComplete = isComplete;
exports.textContent = textContent;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _wrapNativeSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/wrapNativeSuper"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _main = _interopRequireDefault(require("./main"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _debug = _interopRequireDefault(require("debug"));

var _mathRendering = require("@pie-lib/pie-toolbox/math-rendering");

var _piePlayerEvents = require("@pie-framework/pie-player-events");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var log = (0, _debug["default"])('@pie-elements:extended-text-entry');
var domParser = (typeof window === "undefined" ? "undefined" : (0, _typeof2["default"])(window)) !== undefined ? new DOMParser() : {
  parseFromString: function parseFromString(v) {
    return v;
  }
};

function textContent(value) {
  if (typeof value !== 'string') {
    return undefined;
  }

  try {
    var document = domParser.parseFromString(value, 'text/html');
    var _textContent = document.body.textContent;
    return _textContent;
  } catch (err) {
    log('tried to parse as dom and failed', value);
    return value;
  }
}

function isComplete(value) {
  var tc = textContent(value);
  var out = tc !== undefined && tc.length > 0;
  return out;
}

var RootExtendedTextEntry = /*#__PURE__*/function (_HTMLElement) {
  (0, _inherits2["default"])(RootExtendedTextEntry, _HTMLElement);

  var _super = _createSuper(RootExtendedTextEntry);

  function RootExtendedTextEntry() {
    var _this;

    (0, _classCallCheck2["default"])(this, RootExtendedTextEntry);
    _this = _super.call(this);
    _this._model = null;
    _this._session = null;
    return _this;
  }

  (0, _createClass2["default"])(RootExtendedTextEntry, [{
    key: "setLangAttribute",
    value: function setLangAttribute() {
      var language = this._model && (0, _typeof2["default"])(this._model.language) ? this._model.language : '';
      var lang = language ? language.slice(0, 2) : 'en';
      this.setAttribute('lang', lang);
    }
  }, {
    key: "model",
    set: function set(m) {
      this._model = m;
      this.dispatchEvent(new _piePlayerEvents.ModelSetEvent(this.tagName.toLowerCase(), false, !!this._model));
      this.render();
    }
  }, {
    key: "session",
    get: function get() {
      return this._session;
    },
    set: function set(s) {
      this._session = s;
      this.render();
    }
  }, {
    key: "valueChange",
    value: function valueChange(value) {
      this._session.value = value;
      this.dispatchEvent(new _piePlayerEvents.SessionChangedEvent(this.tagName.toLowerCase(), isComplete(value)));
      this.render();
    }
  }, {
    key: "annotationsChange",
    value: function annotationsChange(annotations) {
      this._session.annotations = annotations;
      this.dispatchEvent(new _piePlayerEvents.SessionChangedEvent(this.tagName.toLowerCase(), true));
      this.render();
    }
  }, {
    key: "commentChange",
    value: function commentChange(comment) {
      this._session.comment = comment;
      this.dispatchEvent(new _piePlayerEvents.SessionChangedEvent(this.tagName.toLowerCase(), isComplete(comment)));
      this.render();
    }
  }, {
    key: "connectedCallback",
    value: function connectedCallback() {
      this.setAttribute('aria-label', 'Written Response Question');
      this.setAttribute('role', 'region');
      this.render();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      if (this._model && this._session) {
        var elem = /*#__PURE__*/_react["default"].createElement(_main["default"], {
          model: this._model,
          session: this._session,
          onValueChange: this.valueChange.bind(this),
          onAnnotationsChange: this.annotationsChange.bind(this),
          onCommentChange: this.commentChange.bind(this)
        });

        this.setLangAttribute();

        _reactDom["default"].render(elem, this, function () {
          (0, _mathRendering.renderMath)(_this2);
        });
      }
    }
  }]);
  return RootExtendedTextEntry;
}( /*#__PURE__*/(0, _wrapNativeSuper2["default"])(HTMLElement));

exports["default"] = RootExtendedTextEntry;
//# sourceMappingURL=index.js.map