"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Main = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _debug = _interopRequireDefault(require("debug"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _styles = require("@material-ui/core/styles");

var _editableHtml = require("@pie-lib/pie-toolbox/editable-html");

var _renderUi = require("@pie-lib/pie-toolbox/render-ui");

var _annotationEditor = _interopRequireDefault(require("./annotation/annotation-editor"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var log = (0, _debug["default"])('@pie-ui:extended-text-entry');

var style = function style(theme) {
  return {
    main: {
      backgroundColor: _renderUi.color.background(),
      color: _renderUi.color.text()
    },
    prompt: {
      width: '100%',
      color: _renderUi.color.text(),
      marginBottom: theme.spacing.unit * 2,
      fontSize: 'inherit'
    },
    teacherInstructions: {
      marginBottom: theme.spacing.unit * 2
    },
    editor: {
      marginBottom: theme.spacing.unit * 2,
      borderRadius: '4px'
    },
    srOnly: {
      position: 'absolute',
      left: '-10000px',
      top: 'auto',
      width: '1px',
      height: '1px',
      overflow: 'hidden'
    }
  };
};

var Main = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Main, _React$Component);

  var _super = _createSuper(Main);

  function Main() {
    var _this;

    (0, _classCallCheck2["default"])(this, Main);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "changeSessionValue", (0, _debounce["default"])(_this.props.onValueChange, 1500));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "changeSessionComment", (0, _debounce["default"])(_this.props.onCommentChange, 1500));
    return _this;
  }

  (0, _createClass2["default"])(Main, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          model = _this$props.model,
          classes = _this$props.classes,
          session = _this$props.session,
          onAnnotationsChange = _this$props.onAnnotationsChange;
      var animationsDisabled = model.animationsDisabled,
          annotatorMode = model.annotatorMode,
          customKeys = model.customKeys,
          dimensions = model.dimensions,
          disabled = model.disabled,
          disabledAnnotator = model.disabledAnnotator,
          equationEditor = model.equationEditor,
          extraCSSRules = model.extraCSSRules,
          feedback = model.feedback,
          mathInput = model.mathInput,
          playersToolbarPosition = model.playersToolbarPosition,
          predefinedAnnotations = model.predefinedAnnotations,
          prompt = model.prompt,
          spanishInput = model.spanishInput,
          specialInput = model.specialInput,
          spellCheckEnabled = model.spellCheckEnabled,
          teacherInstructions = model.teacherInstructions;
      var annotations = session.annotations,
          comment = session.comment,
          value = session.value;

      var _ref = dimensions || {},
          width = _ref.width,
          height = _ref.height;

      var maxHeight = '40vh';
      var toolbarOpts = {
        position: playersToolbarPosition === 'top' ? 'top' : 'bottom'
      };
      log('[render] disabled? ', disabled);

      var teacherInstructionsDiv = /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        defaultClassName: "teacher-instructions",
        prompt: teacherInstructions
      });

      var languageCharactersProps = [];

      if (spanishInput) {
        languageCharactersProps.push({
          language: 'spanish'
        });
      }

      if (specialInput) {
        languageCharactersProps.push({
          language: 'special'
        });
      }

      return /*#__PURE__*/_react["default"].createElement(_renderUi.UiLayout, {
        extraCSSRules: extraCSSRules,
        className: classes.main,
        ref: function ref(_ref2) {
          _this2.containerRef = _ref2;
        }
      }, /*#__PURE__*/_react["default"].createElement("h2", {
        className: classes.srOnly
      }, "Constructed Response Question"), teacherInstructions && /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.teacherInstructions
      }, !animationsDisabled ? /*#__PURE__*/_react["default"].createElement(_renderUi.Collapsible, {
        labels: {
          hidden: 'Show Teacher Instructions',
          visible: 'Hide Teacher Instructions'
        },
        className: classes.collapsible
      }, teacherInstructionsDiv) : teacherInstructionsDiv), prompt && /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
        component: 'span',
        className: classes.prompt
      }, /*#__PURE__*/_react["default"].createElement(_renderUi.PreviewPrompt, {
        defaultClassName: "prompt",
        prompt: model.prompt
      })), annotatorMode ? /*#__PURE__*/_react["default"].createElement(_annotationEditor["default"], {
        text: value || '',
        annotations: annotations || [],
        comment: comment || '',
        predefinedAnnotations: predefinedAnnotations || [],
        onChange: onAnnotationsChange,
        onCommentChange: this.changeSessionComment,
        width: width,
        height: height,
        maxHeight: maxHeight,
        disabled: disabledAnnotator,
        disabledMath: !mathInput,
        customKeys: customKeys,
        keypadMode: equationEditor
      }) : /*#__PURE__*/_react["default"].createElement(_editableHtml.EditableHtml, {
        className: (0, _classnames["default"])(classes.editor, 'response-area-editor'),
        onChange: this.changeSessionValue,
        markup: value || '',
        maxWidth: width && width.toString(),
        minWidth: '100px',
        minHeight: height && height.toString(),
        maxHeight: maxHeight,
        disabled: disabled,
        highlightShape: true,
        toolbarOpts: toolbarOpts,
        spellCheck: spellCheckEnabled,
        charactersLimit: 50000,
        autoWidthToolbar: true,
        pluginProps: {
          math: {
            disabled: !mathInput,
            customKeys: this.props.model.customKeys,
            keypadMode: this.props.model.equationEditor,
            controlledKeypadMode: false
          },
          video: {
            disabled: true
          },
          audio: {
            disabled: true
          },
          table: {
            disabled: true
          },
          textAlign: {
            disabled: true
          },
          separateParagraphs: {
            disabled: false
          }
        },
        languageCharactersProps: languageCharactersProps
      }), feedback && /*#__PURE__*/_react["default"].createElement(_renderUi.Feedback, {
        correctness: "correct",
        feedback: feedback
      }));
    }
  }]);
  return Main;
}(_react["default"].Component);

exports.Main = Main;
(0, _defineProperty2["default"])(Main, "propTypes", {
  onValueChange: _propTypes["default"].func.isRequired,
  onAnnotationsChange: _propTypes["default"].func.isRequired,
  onCommentChange: _propTypes["default"].func.isRequired,
  model: _propTypes["default"].object,
  classes: _propTypes["default"].object.isRequired,
  session: _propTypes["default"].shape({
    value: _propTypes["default"].string,
    annotations: _propTypes["default"].array,
    comment: _propTypes["default"].string
  }).isRequired
});

var _default = (0, _styles.withStyles)(style)(Main);

exports["default"] = _default;
//# sourceMappingURL=main.js.map