var feedback$1 = {};

var feedback = {};

var interopRequireDefault = {exports: {}};

(function (module) {
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(interopRequireDefault));

var defineProperty = {exports: {}};

(function (module) {
function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;
}(defineProperty));

var _interopRequireDefault = interopRequireDefault.exports;

Object.defineProperty(feedback, "__esModule", {
  value: true
});
feedback.getFeedbackForCorrectness = feedback.getFeedback = feedback.getActualFeedbackForCorrectness = feedback.getActualFeedback = feedback.defaults = void 0;

var _defineProperty2 = _interopRequireDefault(defineProperty.exports);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var defaults$1 = {
  correct: {
    type: 'default',
    "default": 'Correct',
    custom: 'Correct'
  },
  incorrect: {
    type: 'default',
    "default": 'Incorrect',
    custom: 'Incorrect'
  },
  partial: {
    type: 'default',
    "default": 'Nearly',
    custom: 'Nearly'
  },
  unanswered: {
    type: 'default',
    "default": 'You have not entered a response',
    custom: 'You have not entered a response'
  }
};
/**
 * @typedef {Object} FeedbackConfig
 * @property {'default'|'none'|'custom'} type
 * @property {string} default
 * @property {string} custom
 *
 * @typedef {Object} Feedback
 *  @property {FeedbackConfig} correct
 *  @property {FeedbackConfig} incorrect
 *  @property {FeedbackConfig} partial
 */

feedback.defaults = defaults$1;

var normalizeCorrectness = function normalizeCorrectness(c) {
  if (c === 'partially-correct') {
    return 'partial';
  }

  return c;
};
/**
 * Get the feedback for the correctness
 *
 * @param {'correct'|'incorrect'|'partial'} correctness
 * @param {Feedback} feedback
 */


var getFeedbackForCorrectness = function getFeedbackForCorrectness(correctness, feedback) {
  return new Promise(function (resolve) {
    feedback = _objectSpread(_objectSpread({}, defaults$1), feedback);
    correctness = normalizeCorrectness(correctness);
    var fb = feedback[correctness] || defaults$1[correctness] || {};
    var d = defaults$1[correctness] || {};
    getFeedback(fb, d[fb.type || 'default']).then(function (result) {
      return resolve(result);
    });
  });
};
/**
 * Get the feedback from a {FeedbackConfig}
 *
 * @param {FeedbackConfig} feedback
 * @param {string} fallback
 */


feedback.getFeedbackForCorrectness = getFeedbackForCorrectness;

var getFeedback = function getFeedback(feedback, fallback) {
  return new Promise(function (resolve) {
    if (!feedback || feedback.type === 'none') {
      resolve(undefined);
      return;
    }

    feedback = feedback || {};
    var out = feedback[feedback.type] || fallback;
    resolve(out);
  });
}; // TODO: should replace getFeedbackForCorrectness

/**
 * Get feedback for correctness
 * @param {'correct'|'incorrect'|'partial'} correctness
 * @param {Feedback} feedback
 */


feedback.getFeedback = getFeedback;

var getActualFeedbackForCorrectness = function getActualFeedbackForCorrectness(correctness, feedback) {
  feedback = _objectSpread(_objectSpread({}, defaults$1), feedback); // normalize correctness

  correctness = correctness === 'partially-correct' ? 'partial' : correctness;
  var defaultFeedback = defaults$1[correctness] || {};
  var fb = feedback[correctness] || defaultFeedback;
  return getActualFeedback(fb, defaultFeedback[fb.type || 'default']);
}; // TODO: should replace getFeedback

/**
 * Get the feedback from a {FeedbackConfig}
 * @param {FeedbackConfig} feedback
 * @param {string} fallback
 */


feedback.getActualFeedbackForCorrectness = getActualFeedbackForCorrectness;

var getActualFeedback = function getActualFeedback(feedback, fallback) {
  if (!feedback || feedback.type === 'none') {
    return undefined;
  }

  return feedback[feedback.type] || fallback;
};

feedback.getActualFeedback = getActualFeedback;

(function (exports) {

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "defaults", {
  enumerable: true,
  get: function get() {
    return _feedback.defaults;
  }
});
Object.defineProperty(exports, "getActualFeedback", {
  enumerable: true,
  get: function get() {
    return _feedback.getActualFeedback;
  }
});
Object.defineProperty(exports, "getActualFeedbackForCorrectness", {
  enumerable: true,
  get: function get() {
    return _feedback.getActualFeedbackForCorrectness;
  }
});
Object.defineProperty(exports, "getFeedback", {
  enumerable: true,
  get: function get() {
    return _feedback.getFeedback;
  }
});
Object.defineProperty(exports, "getFeedbackForCorrectness", {
  enumerable: true,
  get: function get() {
    return _feedback.getFeedbackForCorrectness;
  }
});

var _feedback = feedback;

}(feedback$1));

var defaults = {
  annotationsEnabled: false,
  dimensions: { height: 100, width: 500 },
  equationEditor: 'Grade 8 - HS',
  feedbackEnabled: false,
  mathInput: false,
  playerSpellCheckDisabled: true,
  predefinedAnnotations: [
    { label: 'good', text: 'good', type: 'positive' },
    { label: '★', text: '★', type: 'positive' },
    { label: ':-)', text: ':-)', type: 'positive' },
    { label: 'creative', text: 'creative', type: 'positive' },
    { label: 'run-on', text: 'run-on', type: 'negative' },
    { label: 'frag', text: 'fragment', type: 'negative' },
    { label: 'tran', text: 'transition', type: 'negative' },
    { label: 'supp', text: 'support needed', type: 'negative' },
    { label: 'punc', text: 'punctuation', type: 'negative' },
    { label: 'agr', text: 'agreement wrong', type: 'negative' },
    { label: 'unclear', text: 'unclear', type: 'negative' },
    { label: 'cut', text: 'cut', type: 'negative' },
    { label: 'sp', text: 'spelling', type: 'negative' },
    { label: 'cap', text: 'capitalization', type: 'negative' },
    { label: 'inf', text: 'informal', type: 'negative' },
    { label: 'awk', text: 'awkward', type: 'negative' },
  ],
  prompt: '',
  promptEnabled: true,
  rationale: '',
  rationaleEnabled: true,
  studentInstructionsEnabled: true,
  teacherInstructions: '',
  teacherInstructionsEnabled: true,
  toolbarEditorPosition: 'bottom',
};

async function createDefaultModel(model = {}) {

  return { ...defaults, ...model };
}

const normalize = (question) => ({ ...defaults, ...question });

async function model(question, session, env) {
  const normalizedQuestion = normalize(question);

  const fb =
    env.mode === 'evaluate' && normalizedQuestion.feedbackEnabled
      ? feedback$1.getFeedback(normalizedQuestion.feedback, 'Your answer has been submitted')
      : Promise.resolve(undefined);

  let teacherInstructions = null;
  if (env.role === 'instructor' && (env.mode === 'view' || env.mode === 'evaluate')) {
    teacherInstructions = normalizedQuestion.teacherInstructionsEnabled ? normalizedQuestion.teacherInstructions : null;
  } else {
    teacherInstructions = null;
  }

  let equationEditor = normalizedQuestion.equationEditor || 'miscellaneous';

  switch (normalizedQuestion.equationEditor) {
    case 'Grade 1 - 2':
      equationEditor = 1;
      break;
    case 'Grade 3 - 5':
      equationEditor = 3;
      break;
    case 'Grade 6 - 7':
      equationEditor = 6;
      break;
    case 'Grade 8 - HS':
      equationEditor = 8;
      break;
  }

  const annotatorMode = normalizedQuestion.annotationsEnabled && (env.role === 'instructor' || env.mode === 'evaluate');

  return fb.then((feedback) => ({
    prompt: normalizedQuestion.promptEnabled ? normalizedQuestion.prompt : null,
    dimensions: normalizedQuestion.dimensions,
    customKeys: normalizedQuestion.customKeys || [],
    id: normalizedQuestion.id,
    disabled: env.mode !== 'gather',
    feedback,
    teacherInstructions,
    language:normalizedQuestion.language,
    mathInput: normalizedQuestion.mathInput,
    spanishInput: normalizedQuestion.spanishInput,
    specialInput: normalizedQuestion.specialInput,
    equationEditor,
    spellCheckEnabled: !normalizedQuestion.playerSpellCheckDisabled,
    playersToolbarPosition: normalizedQuestion.playersToolbarPosition || 'bottom',
    annotatorMode,
    disabledAnnotator: normalizedQuestion.annotationsEnabled ? env.role !== 'instructor' : true,
    predefinedAnnotations: normalizedQuestion.annotationsEnabled ? normalizedQuestion.predefinedAnnotations : [],
    extraCSSRules: normalizedQuestion.extraCSSRules,
  }));
}

async function outcome(/*question, session, env*/) {
  return {
    score: 0,
    completed: 'n/a',
    note: 'Requires manual scoring',
  };
}

// remove all html tags except img, iframe and source tag for audio
const getContent = (html) => (html || '').replace(/(<(?!img|iframe|source)([^>]+)>)/gi, '');

const validate = (model = {}, config = {}) => {
  const errors = {};

  ['teacherInstructions', 'prompt'].forEach((field) => {
    if (config[field]?.required && !getContent(model[field])) {
      errors[field] = 'This field is required.';
    }
  });

  return errors;
};

export { createDefaultModel, model, normalize, outcome, validate };
