import Configure from './configure.js';
import Element from './element.js';
import * as controller from './controller.js';

var generate = {};

generate.model = (id, element) => ({
  id,
  element,
  customKeys: ['\\square'],
  feedback: { type: 'default', default: 'this is default feedback' },
  prompt: 'This is the question prompt',
  promptEnabled: true,
  mathInput: true,
  playersToolbarPosition: 'bottom',
  toolbarEditorPosition: 'bottom',
  spellCheckEnabled: true,
  rubricEnabled: false,
  annotationsEnabled: false,
});

const { model } = generate;
var config = {
  elements: {
    'extended-text-entry': '../..',
  },
  models: [model('1', 'extended-text-entry')],
};

//Note: demo-el is a custom element loaded in the markup.
  customElements.whenDefined("demo-el").then(() => {
    config.models.forEach((m) => {
      const de = document.createElement("demo-el");
      document.body.appendChild(de);
      de.def = { tagName: m.element, Element, Configure, controller };
      de.model = m;
    });
  });
