import PrintElement from './print.js';

var generate = {};

generate.model = (id, element) => ({
  id,
  element,
  customKeys: ['\\square'],
  feedback: { type: 'default', default: 'this is default feedback' },
  prompt: 'This is the question prompt',
  promptEnabled: true,
  mathInput: true,
  playersToolbarPosition: 'bottom',
  toolbarEditorPosition: 'bottom',
  spellCheckEnabled: true,
  rubricEnabled: false,
  annotationsEnabled: false,
});

const { model } = generate;
var config = {
  elements: {
    'extended-text-entry': '../..',
  },
  models: [model('1', 'extended-text-entry')],
};

// new init - just shows off print!

const init = async () => {
  console.log('define the element...');
  await Promise.all(
    config.models.map(async (m) => {
      try {
        const printTag = `${m.element}-print`;
        if (customElements.get(printTag)) {
          return true;
        } else {
          customElements.define(printTag, PrintElement);
          await customElements.whenDefined(printTag);
          return true;
        }
      } catch (e) {
        return false;
      }
    })
  );

  console.log('now apply the model...');
  config.models.forEach((m) => {
    const printTag = `${m.element}-print`;
    const h3s = document.createElement('h3');
    h3s.textContent = 'student mode';
    document.body.appendChild(h3s);
    const de = document.createElement(printTag);
    document.body.appendChild(de);
    de.options = {};
    de.model = m;

    const h3 = document.createElement('h3');
    h3.textContent = 'instructor mode';
    document.body.appendChild(h3);
    const instr = document.createElement(printTag);
    document.body.appendChild(instr);
    instr.options = { mode: 'instructor' };
    instr.model = JSON.parse(JSON.stringify(m));
  });
};

init()
  .then(() => {
    console.log('ready');
  })
  .catch((e) => {
    console.error(e);
  });
